#include "Boss1.h"

Boss1::Boss1(Player * p, ALLEGRO_BITMAP * image, int x_, int y_, int Pos){
	position = Pos;// del 0 - 7 para la imagen scout.png (vease la imagen)
	prota = p;
	name = "Vago";
	move = true;// movimiento en general
	moveX = true;//en eje x
	moveY = false;//en eje y
	cont = 1;
	info = al_load_bitmap("imagenes/objetos/text_box.png");
	font = al_load_ttf_font("fuentes/arial.ttf", 25, 0);
	x = x_;
	y = y_;
	Init(image);
}

void Boss1::Init(ALLEGRO_BITMAP * image){
	SetID(ENEMY);
	SetAlive(true);
	life = 25;
	GameObject::Init(x, y, 5, 5, 0, 0, 25, 35);
	al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
	say = al_load_sample("sonidos/got.ogg");
	lf = new Wall(625, 15, al_load_bitmap("imagenes/Sprites/life_boss1.png"), prota, 1);
	dead = new Wall(510, 225, al_load_bitmap("imagenes/Objetos/tumba.png"), prota, Wall::TOMB);
	key1 = new Key(320, 225, al_load_bitmap("imagenes/Items/key1.png"),1);
	if (prota->k1)
		SetAlive(false);
	curFrame = 0;
	frameWidth = 56;
	frameHeight = 71;
	animationColumns = 1;
	animationRow = 1;
	if (image != NULL)
		this->image = image;
}

void Boss1::Update(){
	if (this->GetAlive()) {
		GameObject::Update();
		for (iter = spawn.begin(); iter != spawn.end();) {
			(*iter)->Update();
			if (!(*iter)->GetAlive()) {
				(*iter)->Destroy();
				delete(*iter);
				iter = spawn.erase(iter);
			}
			else { iter++; }
		}

		if (x < 75) {
			SetX(75);
			moveX = !moveX;
		}
		else if (x > 565) {
			SetX(565);
			moveX = !moveX;
		}

		if (y < 95) {
			SetY(95);
			moveY = !moveY;
		}
		else if (y > 360) {
			SetY(360);
			moveY = !moveY;
		}
		if (life <= 0) {
			SetAlive(false);
		}

		if (cont % 100 == 0) {
			Bullet *bullet0 = new Bullet(this->GetX(), this->GetY(), 0);
			Bullet *bullet1 = new Bullet(this->GetX(), this->GetY(), 1);
			Bullet *bullet2 = new Bullet(this->GetX(), this->GetY(), 2);
			Bullet *bullet3 = new Bullet(this->GetX(), this->GetY(), 3);
			spawn.push_back(bullet0);
			spawn.push_back(bullet1);
			spawn.push_back(bullet2);
			spawn.push_back(bullet3);
		}
		if (cont % 10 == 0) {
			if (moveY) {
				MoveUp();
			}
			else {
				MoveDown();
			}
		}
		if (move) {
			if (moveX) {
				MoveRight();
			}
			else {
				MoveLeft();
			}
		}
		cont++;
	}
	else {
		dead->Update();
		if (!prota->k1) {
			if (prota->CheckCollisions(key1)) {
				key1->Collided(prota->GetID());
				prota->Collided(key1->GetID());
				prota->k1 = true;
			}
		}
	}
}

void Boss1::Render(){
	if (this->GetAlive()) {
		int fx = 0;
		int fy = animationRow * frameHeight;
		al_draw_bitmap_region(image, fx, fy, frameWidth, frameHeight,
			x - frameWidth / 2, y - frameHeight / 2, 0);

		lf->Render();//<-- life image

		for (iter = spawn.begin(); iter != spawn.end(); iter++)
			(*iter)->Render();

		al_draw_textf(font, al_map_rgb(62, 4, 61), 580, 5, ALLEGRO_ALIGN_CENTRE, "*%i*", this->getLife());
	}
	else {
		SetX(510);
		SetY(225);
		dead->Render();
		if (!prota->k1)
			key1->Render();

	}
}

void Boss1::Collided(int objectID) {
	if (objectID == BULLET) {
		life--;
	}
}

void Boss1::Destroy(){
	Enemy::Destroy();
	delete(dead);
	delete(lf);
	delete(key1);
}
