#include "Boss2.h"

Boss2::Boss2(Player * p, ALLEGRO_BITMAP * image, int x_, int y_, int Pos) {
	position = Pos;// del 0 - 7 para la imagen scout.png (vease la imagen)
	prota = p;
	move = true;// movimiento en general
	moveX = false;//en eje x
	moveY = false;//en eje y
	name = "Guaren";
	cont = 1;
	info = al_load_bitmap("imagenes/objetos/text_box.png");
	font = al_load_ttf_font("fuentes/arial.ttf", 25, 0);
	x = x_;
	y = y_;
	Init(image);
}

void Boss2::Init(ALLEGRO_BITMAP * image) {
	SetID(ENEMY);
	SetAlive(true);
	life = 20;
	GameObject::Init(x, y, 5, 5, 0, 0, 35, 37);
	al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
	say = al_load_sample("sonidos/got.ogg");
	lf = new Wall(625, 15, al_load_bitmap("imagenes/Sprites/life_boss2.png"), prota, 1);
	dead = new Wall(510, 225, al_load_bitmap("imagenes/Objetos/tumba.png"), prota, Wall::TOMB);
	key2 = new Key(400, 225, al_load_bitmap("imagenes/Items/key2.png"),2);
	if (prota->k2)
		SetAlive(false);
	curFrame = 0;
	frameWidth = 70;
	frameHeight = 74;
	animationColumns = 1;
	animationRow = 1;
	if (image != NULL)
		this->image = image;
}

void Boss2::Update() {
	if (this->GetAlive()) {
		GameObject::Update();
		for (iter = spawn.begin(); iter != spawn.end();) {
			(*iter)->Update();
			if (!(*iter)->GetAlive()) {
				(*iter)->Destroy();
				delete(*iter);
				iter = spawn.erase(iter);
			}
			else { iter++; }
		}

		if (x < 75) {
			SetX(75);
			moveX = !moveX;
		}
		else if (x > 565) {
			SetX(565);
			moveX = !moveX;
		}

		if (y < 95) {
			SetY(95);
			moveY = !moveY;
		}
		else if (y > 360) {
			SetY(360);
			moveY = !moveY;
		}
		if (life <= 0) {
			SetAlive(false);
		}

		if (cont % 500 == 0 || cont==100) {
			Enemy *rat0 = new Enemy(prota, al_load_bitmap("imagenes/Sprites/rat.png"), 100, 150, 0, 0);
			Enemy *rat1 = new Enemy(prota, al_load_bitmap("imagenes/Sprites/rat.png"), this->GetX() - 30, this->GetY(), 0, 0);
			Enemy *rat2 = new Enemy(prota, al_load_bitmap("imagenes/Sprites/rat.png"), 100, 330, 0, 0);
			spawn.push_back(rat0);
			spawn.push_back(rat1);
			spawn.push_back(rat2);
		}
		if (cont % 10 == 0) {
			if (moveY) {
				MoveUp();
			}
			else {
				MoveDown();
			}
		}
		cont++;
	}
	else {
		dead->Update();
		if (!prota->k2) {
			if (prota->CheckCollisions(key2)){
				key2->Collided(prota->GetID());
				prota->Collided(key2->GetID());
				prota->k2 = true;
			}
		}
	}
}

void Boss2::Render() {
	if (this->GetAlive()) {
		int fx = 0;
		int fy = 0;
		al_draw_bitmap_region(image, fx, fy, frameWidth, frameHeight,
			x - frameWidth / 2, y - frameHeight / 2, 0);

		lf->Render();//<-- life image

		for (iter = spawn.begin(); iter != spawn.end(); iter++)
			(*iter)->Render();

		al_draw_textf(font, al_map_rgb(62, 4, 61), 580, 5, ALLEGRO_ALIGN_CENTRE, "*%i*", this->getLife());
	}
	else {
		SetX(510);
		SetY(225);
		dead->Render();
		if (!prota->k2)
			key2->Render();

	}
}

void Boss2::Collided(int objectID) {
	if (objectID == BULLET) {
		life--;
	}
}

void Boss2::Destroy() {
	Enemy::Destroy();
	delete(dead);
	delete(lf);
	delete(key2);
}

