#include "Enemy.h"

Enemy::Enemy(){}

Enemy::Enemy(Player * p, ALLEGRO_BITMAP * image, int x_, int y_, int pos, int Type){
	position = pos;// del 0 - 7 para la imagen scout.png (vease la imagen)
	prota = p;
	type = Type;//ID es para acceder a diferentes acciones dentro de una Room, diferente a ID de gameobject
	move = true;// movimiento en general
	moveX = true;//en eje x
	moveY = false;//en eje y
	cont = 1;
	info = al_load_bitmap("imagenes/objetos/text_box.png");
	font = al_load_ttf_font("fuentes/arial.ttf", 25, 0);
	x = x_;
	y = y_;
	Init(image);
}

void Enemy::Init(ALLEGRO_BITMAP * image){
	SetID(ENEMY);
	SetAlive(true);
	life = 10;
	if (type == 0) {//0:rat 1:boss1 2:monster 3:monster 4:monster 5:boss2
		life = 3;
		GameObject::Init(x, y, 3, 3, 0, 0, 16, 16);
		al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
		//say = al_load_sample("sonidos/got.ogg");
		curFrame = 3;
		frameWidth = 32;
		frameHeight = 32;
		animationColumns = 3;
		animationRow = 2;
	}
	if (image != NULL)
		NPC::image = image;
}

void Enemy::Update() {
	if (this->GetAlive()) {
		GameObject::Update();
		for (iter = spawn.begin(); iter != spawn.end();) {
			(*iter)->Update();
			if (!(*iter)->GetAlive()) {
				(*iter)->Destroy();
				delete(*iter);
				iter = spawn.erase(iter);
			}
			else { iter++; }
		}

		if (x < 75) {
			SetX(75);
			moveX = !moveX;
		}
		else if (x > 565) {
			SetX(565);
			moveX = !moveX;
		}

		if (y < 95) {
			SetY(95);
			moveY = !moveY;
		}
		else if (y > 360) {
			SetY(360);
			moveY = !moveY;
		}
		if (life <= 0) {
			SetAlive(false);
		}
		//type 0
		if (type == 0) {
			if (cont % 10 == 0) {
				if (prota->GetY() < this->GetY()) {
					MoveUp();
					if (this->GetY() - 3 <= prota->GetY()) { MoveDown(); }
				}
				if (prota->GetY() > this->GetY()) {
					MoveDown();
					if (this->GetY() + 3 >= prota->GetY()) { MoveUp(); }
				}
				if (prota->GetX() < this->GetX()) {
					MoveLeft();
					if (this->GetX() + 3 >= prota->GetX()) { MoveLeft(); }
				}
				if (prota->GetX() > this->GetX()) {
					MoveRight();
					if (this->GetX() - 3 <= prota->GetX()) { MoveRight(); }
				}
			}
			cont++;
		}
	}
}

void Enemy::Render(){
	if (type == 0) {
		int fx = ((curFrame / 3) % animationColumns) * frameWidth;
		int fy = animationRow * frameHeight;
		al_draw_bitmap_region(image, fx, fy, frameWidth, frameHeight,
			x - frameWidth / 2, y - frameHeight / 2, 0);
	}
}

void Enemy::MoveUp(){
	animationRow = 3;
	dirY = -1;
	curFrame++;
}

void Enemy::MoveDown(){
	animationRow = 0;
	dirY = 1;
	curFrame++;
}

void Enemy::MoveLeft(){
	animationRow = 1;
	curFrame++;
	dirX = -1;
}

void Enemy::MoveRight(){
	animationRow = 2;
	curFrame++;
	dirX = 1;
}

void Enemy::Collided(int objectID){
	if (objectID == BULLET) {
		life--;
	}
}

void Enemy::destroy_ammo() {
	for (iter = spawn.begin(); iter != spawn.end(); iter++)
		(*iter)->Destroy();
}

void Enemy::Destroy() {
	NPC::Destroy();
	destroy_ammo();
	SetAlive(false);
}
