
#include "Explosion.h"

Explosion::Explosion(float x, float y, ALLEGRO_BITMAP *image){
	GameObject::Init(x, y, 0, 0, 0, 0, 0, 0);

	SetID(EXPLOSION);
	SetCollidable(false);

	maxFrame = 31;
	curFrame = 0;
	frameWidth = 128;
	frameHeight = 128;
	animationColumns = 8;

	Explosion::image = image;
}

void Explosion::Destroy(){
	GameObject::Destroy();
}

void Explosion::Update(){
	GameObject::Update();

	curFrame ++;
	if(curFrame >= maxFrame)
		SetAlive(false);

}

void Explosion::Render(){

	int fx = (curFrame % animationColumns) * frameWidth;
	int fy = (curFrame / animationColumns) * frameHeight;

	al_draw_bitmap_region(image, fx, fy, frameWidth,
		frameHeight, x - frameWidth / 2, y - frameHeight / 2, 0);
}