#include "NPC.h"

NPC::NPC(){}

NPC::NPC(Player *p, ALLEGRO_BITMAP *image, int x_, int y_, int pos, int Type, Texto *t) {
	position = pos;// del 0 - 7 para la imagen scout.png (vease la imagen)
	prota = p;
	type = Type;//ID es para acceder a diferentes acciones dentro de una Room
	move = true;// movimiento en general
	moveX = true;//en eje x
	moveY = false;//en eje y
	cont = 1;
	x = x_;
	y = y_;
	info = al_load_bitmap("imagenes/Objetos/text_box.png");
	Init(image);
	txt = t;
	linea = txt->getLinea();
	lineas = txt->getLineas();
}

void NPC::Init(ALLEGRO_BITMAP *image) {
	GameObject::Init(x, y, 2, 2, 0, 0, 16, 16);
	al_convert_mask_to_alpha(image, al_map_rgb(155, 188, 15));
	say = al_load_sample("sonidos/got.ogg");
	SetID(NPCs);
	SetAlive(true);

	curFrame = 1;
	frameWidth = 32;
	frameHeight = 32;
	animationColumns = 3;
	animationRow = 0;

	if (image != NULL)
		NPC::image = image;
}


void NPC::Update() {
	GameObject::Update();
	if (x < 0)
		x = 0;
	else if (x > WIDTH)
		x = WIDTH;

	if (y < 0)
		y = 0;
	else if (y > HEIGHT)
		y = HEIGHT;
	if (type == 0) {
		if (cont % 50 == 0) {
			moveX = !moveX;
		}
		if (this->CheckCollisions((GameObject*)prota)) {
			Collided(prota->GetID());
		}
		else { move = true; }

		if (move) {
			if (moveX) {
				MoveRight();
			}
			else {
				MoveLeft();
			}
			cont++;
		}
	}
	if (type == 1) {
		if (cont % 50 == 0) {
			moveY = !moveY;
		}
		if (this->CheckCollisions((GameObject*)prota)) {
			Collided(prota->GetID());
		}
		else { move = true; }

		if (move) {
			if (moveY) {
				MoveDown();
			}
			else {
				MoveUp();
			}
			cont++;
		}
	}
}

void NPC::Render() {
	if (position < 4) {
		int fx = ((curFrame / 3) % animationColumns) * frameWidth + 3* frameWidth*position;
		int fy = animationRow * frameHeight;
		al_draw_bitmap_region(image, fx, fy, frameWidth, frameHeight,
			x - frameWidth / 2, y - frameHeight / 2, 0);
	}
	else {
		int pos = position % 4;
		int fx = (((curFrame / 3) % animationColumns) * frameWidth) + 3*frameWidth*pos;
		int fy = (animationRow * frameHeight + 4 * frameHeight);
		al_draw_bitmap_region(image, fx, fy, frameWidth, frameHeight,
			x - frameWidth / 2, y - frameHeight / 2, 0);
	}
	if (this->CheckCollisions(prota)) {
		if (prota->getInfo()) {
			al_draw_bitmap(info, 90, 300, 0);
			txt->print();
		}
	}
}

void NPC::MoveUp() {
	animationRow = 3;
	dirY = -1;
	curFrame++;
	prota->setInfo(false);
}
void NPC::MoveDown() {
	animationRow = 0;
	dirY = 1;
	curFrame++;
	prota->setInfo(false);
}
void NPC::MoveLeft() {
	animationRow = 1;
	curFrame++;
	dirX = -1;
	prota->setInfo(false);
}
void NPC::MoveRight() {
	animationRow = 2;
	curFrame++;
	dirX = 1;
	prota->setInfo(false);
}

void NPC::ResetAnimation(int position) {
	if (position == 1) {
		dirY = 0;
	}
	else {
		dirX = 0;
	}
}

void NPC::Collided(int objectID) {
	if (objectID == GUN) {
		al_play_sample(say, 1, 0, 1, ALLEGRO_PLAYMODE_ONCE, 0);
	}
	if(objectID == PLAYER){
		move = !move;
		dirX = 0;
		dirY = 0;
	}
}
/*! @brief Metodo boundary.
*			Lmites(dimensional) del objeto.
*
* Se encarga de verificar si el "NPC" est colisionando con "Player",
* recibe Entero que indica hacia donde mira el personaje, vease "enum dir".
*/
void NPC::boundary(int num) {
	if (prota->GetY() < y + GetBoundY() + CACHO &&
		prota->GetY() > y &&
		prota->GetX() < x + GetBoundX() &&
		prota->GetX() > x - GetBoundX() &&
		num == UP) {
		prota->SetY(y + GetBoundY());
	}
	else if (prota->GetY() > (y - GetBoundY() - BORDE - CACHO) &&
		prota->GetY() < y &&
		prota->GetX() < x + GetBoundX() &&
		prota->GetX() > x - GetBoundX() &&
		num == DOWN) {
		prota->SetY(y - GetBoundY() - BORDE);// el CACHO es para evitar el tambaleo
	}
	else if (prota->GetX() < x + GetBoundX() + CACHO &&
		prota->GetX() > x  &&
		prota->GetY() < y + GetBoundY() &&
		prota->GetY() > y - GetBoundY() - BORDE &&
		num == LEFT) {
		prota->SetX(x + GetBoundX() + CACHO);// el CACHO es para evitar el tambaleo 
	}
	else if (prota->GetX() > x - GetBoundX() - CACHO &&
		prota->GetX() < x &&
		prota->GetY() < y + GetBoundY() &&
		prota->GetY() > y - GetBoundY() - BORDE &&
		num == RIGHT) {
		prota->SetX(x - GetBoundX() - CACHO);
	}
}

void NPC::Destroy() {
	GameObject::Destroy();
	al_destroy_sample(say);
}