#pragma once

#include "GameObject.h"
#include "Player.h"
#include "Texto.h"
#include <allegro5/allegro_audio.h>
#include <allegro5/allegro_ttf.h>
#define	BORDE 15
#define CACHO 5

class NPC : public GameObject {
private:
	Texto *txt = NULL;/**< Puntero a objeto manipulador de archivo de texto. */
	int lineas;/**< Entero, lineas totales en texto. */
	char *linea;/**< Cadena de chars, linea que se acaba de leer en el archivo. */
protected:
	int position;/**< Posicin del sprite en una imagen con muchos sprites(vease scout.png), orden de izquierda a derecha. */
	int cont;/**< Entero, N de pasos. */
	int type;/**< Entero, tipo de NPC(Cada tipo accede a acciones especiales diferentes, vease mtodo update). */
	bool move;/**< Booleano, se mueve?. */
	bool moveX;/**< Booleano, Se mueve hacia la izquierda o a la derecha?, true si es derecha. */
	bool moveY;/**< Booleano, Se mueve hacia arriba o abajo?, true si es hacia abajo. */
	enum Dir{UP, DOWN, LEFT, RIGHT};/**< Enumeracin de las direcciones posibles. */
	Player *prota = NULL;/**< Puntero al protagonista. */
	ALLEGRO_BITMAP *info = NULL;/**< Puntero a una imagen, caja de dialogo. */
	ALLEGRO_SAMPLE *say = NULL;/**< Puntero a sonido o msica. */
	ALLEGRO_FONT *font = NULL;/**< Puntero a archivo TrueType. */
public:
	NPC();
	NPC(Player *p, ALLEGRO_BITMAP *image, int x_, int y_, int pos, int ID, Texto *t);
	void Destroy();

	void Init(ALLEGRO_BITMAP *image = NULL);

	void Update();
	void Render();

	void MoveUp();
	void MoveDown();
	void MoveLeft();
	void MoveRight();

	void ResetAnimation(int pos);

	int GetPosition() { return position; }

	void Collided(int objectID);

	void boundary(int num);
};