#pragma once

#include "GameObject.h"
#include "Bullet.h"
#include <list>
#include <allegro5/allegro_audio.h>

/*! @brief Clase Player.
*			Hereda los metodos set, get, CheckCollisions, entre otros relacionados.
*
*
* La clase Player contiene metodos necesarios para realizar las acciones llamadas
* a travs del teclado, sean estas disparar, moverse, cambiar de sala, etc.
*/
class Player : public GameObject {
private:
	int life;/**< Entero que tiene como valor la vida actual del personaje. */
	int deads;/**< Entero que contabiliza las muertes. */
	int max_Life;/**< Entero que contiene el valor maximo de vida del personaje. */
	int score;/**< Entero, contiene la puntuacin total durante la partida. */
	int set;/**< Entero, representa hacia que direccin se diriga el personaje al cambiar de sala, siendo sus valores  1:up 2:down 3:left 4:right. */
	bool gun;/**< Booleano que detecta la posesin de un arma. */
	bool change;/**< Booleano que representa si el personaje ha cambiado de sala, tiene valor true si lo ha hecho. */
	bool info;/**< Booleano, es true si el boton ACTION est activado(hablar con NPCs). */
	int room;/**< Entero que representa la estructura de la sala en la que nos encontramos. */
	int type_Room;/**< Entero que representa el tipo de sala con una estructura definida por la variable "room". */
	ALLEGRO_SAMPLE *get = NULL;/**< Puntero a msica o tono. */
	ALLEGRO_BITMAP *bgImage = NULL;/**< Puntero al sprite del personaje. */

public:
	std::list<GameObject *> ammo;/**< Lista para las municiones(balas del arma). */
	std::list<GameObject *>::iterator iter;/**< Iterador de la lista. */
	bool k1, k2, k3, k4, k5, k6, k7;/**< Booleanos, representan las llaves arrojadas por los "Boss" luego de ser asesinados, pblicos para facilitar gets (son demasiados para crear un metodo para cada uno). */
	Player(ALLEGRO_BITMAP *image = NULL);

	void Destroy();

	void Init(ALLEGRO_BITMAP *image = NULL);

	void new_Init();
	void Update();
	void Render();
	
	void shoot();
	void destroy_ammo();

	bool getGun() { return gun; }
	void setGun(bool t) { gun = t; }

	void setSet(int s) { set = s; }
	int getSet() { return set; }

	bool getChange() { return change; }
	void setChange(bool change) { this->change = change; }

	void setRoom(int r) { room = r; }
	int getRoom() { return room; }

	void setType_Room(int id_room) { type_Room = id_room; }
	int getType_Room() { return type_Room; }
	void MoveUp();
	void MoveDown();
	void MoveLeft();
	void MoveRight();

	void ResetAnimation(int pos);

	bool getInfo() { return info; }
	void setInfo(bool stop) { info = stop; }

	int GetLife() { return life; }
	int GetScore() { return score; }
	int GetPosition() { return animationRow; }

	void add_Dead() { deads++; }
	void LoseLife() { life--; }
	void setLife(int l) { life = l; }
	int getLife() { return life; }
	int get_Max_Life() { return max_Life; }
	void set_Max_Life(int ml) { max_Life = ml; }
	void AddPoint() { score++; }

	void Collided(int objectID);
};