#include "Room.h"

Room::Room(ALLEGRO_BITMAP * image, Player *p, float velX) :Background(image, velX) { contador = 0; }
/*! @brief Metodo list_Collided.
*			Colisines con una lista .
*
* Este mtodo nos ayuda a verificar si un objeto cualquiera est colisionando,
* con algn objeto de la lista en cuestion.
*/
void Room::boundary(int num){}
/*! @brief Metodo list_Collided.
*			Colisines con una lista .
*
* Este mtodo nos ayuda a verificar si un objeto cualquiera est colisionando,
* con algn objeto de la lista en cuestion.
*/
void Room::list_Collided(std::list<GameObject *> list, GameObject * go) {
	for (iter = list.begin(); iter != list.end(); ++iter) {
		if (!(*iter)->Collidable()) continue;
		if ((*iter)->GetID() == go->GetID()) continue;

		if ((*iter)->CheckCollisions(go)) {
			if ((go->GetID() == PLAYER && (*iter)->GetID() == ENEMY)) {
				if (contador % 50 == 0) {
					(*iter)->Collided(go->GetID());
					go->Collided((*iter)->GetID());
				}
				contador++;
			}
			else {
				(*iter)->Collided(go->GetID());
				go->Collided((*iter)->GetID());
			}
		}
	}
}
/*! @brief Metodo sameList_Collided.
*			Lista con la misma lista.
*
* Verifica si existe colisin entre objetos en una misma lista.
*/
void Room::sameList_Collided(){
	for (iter = spawn.begin(); iter != spawn.end(); ++iter) {
		if (!(*iter)->Collidable()) continue;

		for (iter2 = iter; iter2 != spawn.end(); ++iter2) {
			if (!(*iter2)->Collidable()) continue;
			if ((*iter)->GetID() == (*iter2)->GetID()) continue;

			if ((*iter)->CheckCollisions((*iter2))) {
				if (((*iter)->GetID() == PLAYER && (*iter2)->GetID() == ENEMY) || ((*iter)->GetID() == ENEMY && (*iter2)->GetID() == PLAYER)) {
					if (contador % 50 == 0) {
						(*iter)->Collided((*iter2)->GetID());
						(*iter2)->Collided((*iter)->GetID());
					}
					contador++;
				}
				else {
					(*iter)->Collided((*iter2)->GetID());
					(*iter2)->Collided((*iter)->GetID());
				}
			}
		}
	}
}
/*! @brief Metodo list_to_list.
*			lista con lista.
*
* Verifica si existe colisin de objetos de una lista con otros de otra lista.
*/
void Room::list_to_list(std::list<GameObject*> list, std::list<GameObject*> list2){
	for (iter = list.begin(); iter != list.end(); ++iter) {
		if (!(*iter)->Collidable()) continue;

		for (iter2 = list2.begin(); iter2 != list2.end(); ++iter2) {
			if (!(*iter2)->Collidable()) continue;
			if ((*iter)->GetID() == (*iter2)->GetID()) continue;

			if ((*iter)->CheckCollisions((*iter2))) {
				if (((*iter)->GetID() == PLAYER && (*iter2)->GetID() == ENEMY) || ((*iter)->GetID() == ENEMY && (*iter2)->GetID() == PLAYER)) {
					if (contador % 50 == 0) {
						(*iter)->Collided((*iter2)->GetID());
						(*iter2)->Collided((*iter)->GetID());
					}
					contador++;
				}
				else {
					(*iter)->Collided((*iter2)->GetID());
					(*iter2)->Collided((*iter)->GetID());
				}
			}
		}
	}
}
