#pragma once

#include "Background.h"
#include "Player.h"
#include "Wall.h"
#include "Door.h"
#include "Enemy.h"
#include <allegro5/allegro_audio.h>
#include <allegro5/allegro_ttf.h>
#define	BORDE 15
#define CACHO 5

/*! @brief Clase Room.
*			Salas o partes del mapa.
*
* Son las salas donde el personaje podr moverse e interactuar con otros objetos,
* cada tipo de sala tiene una estructura diferente(entradas y salidas), adems de
* tener en cada estructura diferentes opciones de sala(variable type).
*/
class Room : public Background {
private:
	int contador;/**< Entero, cantidad iteraciones donde un enemigo colisiona con el protagonista. */
protected:
	Player *prota;/**< Puntero al "Player". */
	int type;/**< Entero, tipo de sala(misma estructura), cada tipo tiene diferentes imagenes y objetos. */
	std::list<GameObject *> spawn;/**< Lista spawn, contiene los objetos dentro de la sala. */
	std::list<GameObject *>::iterator iter;/**< Iterador de la lista. */
	std::list<GameObject *>::iterator iter2;/**< Iterador de la lista. */
public:
	Room(ALLEGRO_BITMAP *image, Player *p, float velX);
	virtual void boundary(int num);//num--> 0:up 1:down 2:left 3:right
	void list_Collided(std::list<GameObject *> list, GameObject *go);
	void sameList_Collided();
	void list_to_list(std::list<GameObject *> list, std::list<GameObject *> list2);
	void Active_Cont() { contador++; }
	int getCont() { return contador; }
	bool has_enemy;
};
