#include "Room6.h"

Room6::Room6(ALLEGRO_BITMAP *image, Player *p, int Type) :Room(image, p, velX) {
	prota = p;
	type = Type;
	has_enemy = false;
	down = new Door(320, 460, al_load_bitmap("imagenes/Objetos/door1.png"), false);
	left = new Door(20, 230, al_load_bitmap("imagenes/Objetos/door1_volt.png"), true);
	right = new Door(620, 230, al_load_bitmap("imagenes/Objetos/door1_volt.png"), true);
	if (type == 0) {
		npc0 = new NPC(prota, al_load_bitmap("imagenes/Sprites/scout.png"), 150, 150, 1, 0, new Texto("Textos/wait2.txt"));
		spawn.push_back(npc0);
		block0 = new Wall(310, 440, al_load_bitmap("imagenes/Objetos/reja1_h.png"), prota, Wall::REJA_H);
		block1 = new Wall(600, 235, al_load_bitmap("imagenes/Objetos/reja1_v.png"), prota, Wall::REJA_V);
	}

}
//260 -375
void Room6::boundary(int num) {
	if (prota->GetY() < 95 && num == 0) {
		prota->SetY(95);
	}
	else if (prota->GetY() > 360 && num == 1) {
		if (prota->GetX() > 260 && prota->GetX() < 375) {}
		else { prota->SetY(360); }
	}
	else if (prota->GetX() < 75 && num == 2) {
		if (prota->GetY() > 180 && prota->GetY() < 270) {}
		else { prota->SetX(75); }
	}
	else if (prota->GetX() > 565 && num == 3) {
		if (prota->GetY() > 180 && prota->GetY() < 270) {}
		else { prota->SetX(565); }
	}
	else if (prota->GetX() < 75) {
		if (prota->GetY() < 180 + CACHO && prota->GetY() > 160 && num == 0) { prota->SetY(180 + CACHO); }
		else if (prota->GetY() > 270 - CACHO && prota->GetY() < 280 && num == 1) { prota->SetY(270 - CACHO); }
	}
	else if (prota->GetY() > 360) {
		if (prota->GetX() < 270 && prota->GetX() > 260 && num == 2) { prota->SetX(270); }
		else if (prota->GetX() > 370 && prota->GetX() < 380 && num == 3) { prota->SetX(370); }
	}
	else if (prota->GetX() > 570) {
		if (prota->GetY() < 180 + CACHO && prota->GetY() > 160 && num == 0) { prota->SetY(180 + CACHO); }
		else if (prota->GetY() > 270 - CACHO && prota->GetY() < 280 && num == 1) { prota->SetY(270 - CACHO); }
	}
	if (type == 0) {
		if (npc0->CheckCollisions(prota)) {
			npc0->boundary(num);
		}
		if (block0->CheckCollisions(prota) && !block0->getOpen()) {
			block0->boundary(prota);
			if (prota->k2)
				block0->setOpen(true);
		}
		if (block1->CheckCollisions(prota) && !block1->getOpen()) {
			block1->boundary(prota);
			if (prota->k1)
				block1->setOpen(true);
		}
	}
}

void Room6::Render() {
	al_draw_bitmap(image, x, y, 0);
	if (type == 0) {
		if (!block0->getOpen())
			block0->Render();
		if (!block1->getOpen())
			block1->Render();
	}
	for (iter = spawn.begin(); iter != spawn.end(); iter++)
		(*iter)->Render();
}

void Room6::Update() {
	for (iter = spawn.begin(); iter != spawn.end();) {
		(*iter)->Update();
		if (!(*iter)->GetAlive()) {
			(*iter)->Destroy();
			delete(*iter);
			iter = spawn.erase(iter);
		}
		else { iter++; }
	}
	if (type == 0) {
		if (prota->CheckCollisions(down)) {
			prota->Collided(down->GetID());
			prota->setSet(1);
			prota->setRoom(1);
			prota->setType_Room(1);
		}
		else if (prota->CheckCollisions(left)) {
			prota->Collided(left->GetID());
			prota->setSet(2);
			prota->setRoom(5);
			prota->setType_Room(0);
		}
		else if (prota->CheckCollisions(right)) {
			prota->Collided(right->GetID());
			prota->setSet(3);
			prota->setRoom(3);
			prota->setType_Room(2);
		}
		if (npc0->CheckCollisions(prota)) {
			npc0->Collided(prota->GetID());
		}
	}
}

void Room6::Destroy() {
	delete(down);
	delete(left);
	delete(right);
	for (iter = spawn.begin(); iter != spawn.end(); iter++) {
		(*iter)->Destroy();
		delete(*iter);
	}
	if (type == 0) {
		delete(block0);
		delete(block1);
	}
}


