#include "Wall.h"
#define	BORDE 15
#define CACHO 5

Wall::Wall(float x, float y, ALLEGRO_BITMAP *image, Player *p, int Type){
	prota = p;
	SetID(BORDER);
	type = Type;
	Wall::image = image;
	if (type == ARBOL) {//arbol
		GameObject::Init(x, y, 0, 0, 0, 0, 33, 49);
		al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
		frameWidth = 65;
		frameHeight = 98;
	}
	else if (type == LIFE) {//life
		GameObject::Init(x, y, 0, 0, 0, 0, 16, 16);
		al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
		frameWidth = 32;
		frameHeight = 32;

	}
	else if (type == TOMB) {
		GameObject::Init(x, y, 0, 0, 0, 0, 35, 41);
		al_convert_mask_to_alpha(image, al_map_rgb(9, 9, 9));
		frameWidth = 70;
		frameHeight = 82;
	}
	else if (type == REJA_V) {
		GameObject::Init(x, y, 0, 0, 0, 0, 20, 60);
		al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
		frameWidth = 40;
		frameHeight = 120;
	}
	else if (type == REJA_H) {
		GameObject::Init(x, y, 0, 0, 0, 0, 70, 40);
		al_convert_mask_to_alpha(image, al_map_rgb(255, 255, 255));
		frameWidth = 140;
		frameHeight = 80;
	}
	else if (type == ROCA) {
		GameObject::Init(x, y, 0, 0, 0, 0, 50, 50);
		al_convert_mask_to_alpha(image, al_map_rgb(248, 248, 248));
		frameWidth = 100;
		frameHeight = 100;
	}
}

void Wall::Render(){
	al_draw_bitmap_region(image, 0, 0, frameWidth, frameHeight,
		x - frameWidth / 2, y - frameHeight / 2, 0);
}
/*! @brief Metodo boundary.
*			Lmites(dimensional) del objeto.
*
* Se encarga de verificar si la "Wall" est colisionando con algn objeto.
*/
void Wall::boundary(GameObject * obj){
	if (obj->GetY() < y + GetBoundY() + CACHO &&
		obj->GetY() > y &&
		obj->GetX() < x + GetBoundX()  &&
		obj->GetX() > x - GetBoundX()) {
		obj->SetY(y + GetBoundY() + CACHO);
	}
	else if (obj->GetY() > (y - GetBoundY() - BORDE - CACHO) &&
		obj->GetY() < y &&
		obj->GetX() < x + GetBoundX()  &&
		obj->GetX() > x - GetBoundX()) {
		obj->SetY(y - GetBoundY() - BORDE);// el CACHO es para evitar el tambaleo
	}
	else if (obj->GetX() < x + GetBoundX() + CACHO &&
		obj->GetX() > x  &&
		obj->GetY() < y + GetBoundY() - CACHO &&
		obj->GetY() > y - GetBoundY() - CACHO) {
		obj->SetX(x + GetBoundX() + CACHO);// el CACHO es para evitar el tambaleo 
	}
	else if (obj->GetX() > x - GetBoundX() - CACHO &&
		obj->GetX() < x &&
		obj->GetY() < y + GetBoundY() - CACHO &&
		obj->GetY() > y - GetBoundY() - CACHO) {
		obj->SetX(x - GetBoundX() - CACHO);
	}
}