#pragma once

#include "GameObject.h"
#include "Player.h"

/*! @brief Clase Wall.
*			Pared, obstaculo, etc.
*
* Crea rejas, arboles, rocas que obstaculizarn tu camino.
*/
class Wall : public GameObject {
private:
	int type;/**< Entero que especifica un tipo de objeto(dimensiones, imagen). */
	Player *prota;/**< Puntero al protagonista(Player). */
	bool open;/**< Booleano, indica si la reja est abierta o no. */
public:
	enum Type { ARBOL, LIFE, TOMB, REJA_V, REJA_H, ROCA };/**< Enumeracin de tipos de objetos. */
	Wall(float x, float y, ALLEGRO_BITMAP *image, Player *p, int Type);
	void Render();
	void boundary(GameObject * obj);
	void setOpen(bool Open) { open = Open; }
	int getOpen() { return open; }
	void setType(int t) { type = t; }
	int getType() { return type; }
};