#pragma comment (linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")//<--- oculta la consola <--- 

#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_audio.h>
#include <allegro5/allegro_acodec.h>
#include "Globals.h"//variables globales
#include <list>
#include "GameObject.h"
#include "Bullet.h"
#include "Background.h"
#include "Explosion.h"
#include "Player.h"
#include "Room0.h"
#include "Room1.h"
#include "Room2.h"
#include "Room3.h"
#include "Room4.h"
#include "Room5.h"
#include "Room6.h"
#include "Room7.h"
#include "Room8.h"
#include "Room9.h"
#include "Room10.h"

//globals
ALLEGRO_SAMPLE_INSTANCE *songInstance;/**< Msica de fondo. */
Player *prota;/**< Puntero al protagonista. */
std::list<Room *> Rooms;/**< Lista para las rooms o salas. */
std::list<GameObject *>::iterator iter;/**< Iterador de la lista. */
std::list<GameObject *>::iterator iter2;/**< Otro iterador de la lista. */
bool keys[]={ false, false, false, false, false, false, false, false };/**< Arreglo de booleanos, si la tecla est activada es true. */
Background *titleScreen;/**< Puntero hacia el fondo de titulo. */
Background *lostScreen;/**< Puntero hacia el fondo utilizado al perder. */
Wall *life;/**< Puntero hacia el bloque con la imagen que acompaa la cantidad de vida restante. */
//Funciones
void ChangeState(int &state, int newState);

/*! @brief Mtodo main.
*			Mtodo main.
*
* Contiene el loop que actualiza el juego, junto al el switchs que se activan por eventos
* y un timer para estos.
*/
int main(int argc, char **argv) {
	//==============================================
	//SHELL VARIABLES
	//==============================================
	bool done = false;
	bool render = false;

	float gameTime = 0;
	int frames = 0;
	int gameFPS = 0;

	//==============================================
	//PROJECT VARIABLES
	//==============================================

	int state = -1;
	int max_Life = 0;

	ALLEGRO_BITMAP *protaImage = NULL;
	ALLEGRO_BITMAP *expImage = NULL;
	ALLEGRO_BITMAP *bgImage = NULL;
	ALLEGRO_BITMAP *lifeImage = NULL;
	ALLEGRO_BITMAP *bgImage1 = NULL;
	ALLEGRO_BITMAP *bgImage2 = NULL;
	ALLEGRO_BITMAP *bgImage3 = NULL;
	ALLEGRO_BITMAP *bgImage4 = NULL;
	ALLEGRO_BITMAP *bgImage5 = NULL;
	ALLEGRO_BITMAP *bgImage6 = NULL;
	ALLEGRO_BITMAP *bgImage7 = NULL;
	ALLEGRO_BITMAP *bgImage8 = NULL;
	ALLEGRO_BITMAP *bgImage9 = NULL;
	ALLEGRO_BITMAP *bgImage10 = NULL;
	ALLEGRO_BITMAP *bgImage11 = NULL;
	ALLEGRO_BITMAP *mapImage = NULL;
	ALLEGRO_BITMAP *titleImage = NULL;
	ALLEGRO_BITMAP *lostImage = NULL;
	ALLEGRO_SAMPLE *shot = NULL;
	ALLEGRO_SAMPLE *boom = NULL;
	ALLEGRO_SAMPLE *song = NULL;
	ALLEGRO_SAMPLE *get = NULL;


	//==============================================
	//ALLEGRO VARIABLES
	//==============================================
	ALLEGRO_DISPLAY *display = NULL;
	ALLEGRO_EVENT_QUEUE *event_queue = NULL;
	ALLEGRO_TIMER *timer;
	ALLEGRO_FONT *font;
	ALLEGRO_FONT *font1;

	//==============================================
	//ALLEGRO INIT FUNCTIONS
	//==============================================
	if (!al_init())										//initialize Allegro
		return -1;

	display = al_create_display(WIDTH, HEIGHT);			//create our display object

	if (!display)										//test display object
		return -1;

	//==============================================
	//ADDON INSTALL
	//==============================================
	al_install_keyboard();
	al_init_image_addon();
	al_init_font_addon();
	al_init_ttf_addon();
	al_init_primitives_addon();
	al_install_audio();
	al_init_acodec_addon(); 


	//==============================================
	//PROJECT INIT
	//==============================================
	prota = new Player();
	font = al_load_ttf_font("fuentes/shangri-la.ttf", 50, 0);
	font1 = al_load_ttf_font("fuentes/shangri-la.ttf", 25, 0);
	al_reserve_samples(20);//numero de samples
	lifeImage = al_load_bitmap("imagenes/Sprites/Life.png");
	bgImage = al_load_bitmap("imagenes/Rooms/Begin.png");
	bgImage1 = al_load_bitmap("imagenes/Rooms/Cross_Roads.png");
	bgImage2 = al_load_bitmap("imagenes/Rooms/Altar.png");
	bgImage3 = al_load_bitmap("imagenes/Rooms/End.png");
	bgImage4 = al_load_bitmap("imagenes/Rooms/New_Way.png");
	bgImage5 = al_load_bitmap("imagenes/Rooms/One_Way.png");
	bgImage6 = al_load_bitmap("imagenes/Rooms/No_Way.png");
	bgImage7 = al_load_bitmap("imagenes/Rooms/One_More.png");
	bgImage8 = al_load_bitmap("imagenes/Rooms/Endless_Way.png");
	bgImage9 = al_load_bitmap("imagenes/Rooms/Not_Now.png");
	bgImage10 = al_load_bitmap("imagenes/Rooms/Last_Time.png");
	bgImage11 = al_load_bitmap("imagenes/Rooms/Where_I_Am.png");
	life = new Wall(15, 15, lifeImage, prota, 1);

	Room0 *bg = new Room0(bgImage, prota, 0);
	Rooms.push_back(bg);

	protaImage = al_load_bitmap("imagenes/Sprites/kiltro.png");
	al_convert_mask_to_alpha(protaImage, al_map_rgb(255, 0, 255));
	prota->Init(protaImage);

	expImage = al_load_bitmap("imagenes/Sprites/explosion_3_40_128.png");
	mapImage = al_load_bitmap("imagenes/Objetos/Tutorial.png");
	titleImage = al_load_bitmap("imagenes/Fondos/lsd2.png");
	lostImage = al_load_bitmap("imagenes/Fondos/lsd1.png");

	titleScreen = new Background(titleImage, 0);
	lostScreen = new Background(lostImage, 0);

	shot = al_load_sample("sonidos/gun_shot.ogg");
	boom = al_load_sample("sonidos/boom.ogg");
	song = al_load_sample("sonidos/track.ogg");

	songInstance = al_create_sample_instance(song);
	al_set_sample_instance_playmode(songInstance, ALLEGRO_PLAYMODE_LOOP);
	al_attach_sample_instance_to_mixer(songInstance, al_get_default_mixer());

	ChangeState(state, TITLE);

	//==============================================
	//TIMER INIT AND STARTUP
	//==============================================
	event_queue = al_create_event_queue();
	timer = al_create_timer(1.0 / 60);

	al_register_event_source(event_queue, al_get_timer_event_source(timer));
	al_register_event_source(event_queue, al_get_keyboard_event_source());

	al_start_timer(timer);
	gameTime = al_current_time();

	while (!done) {
		ALLEGRO_EVENT ev;
		al_wait_for_event(event_queue, &ev);

		//==============================================
		//INPUT
		//==============================================
		if (ev.type == ALLEGRO_EVENT_KEY_DOWN ) {
			switch (ev.keyboard.keycode) {
			case ALLEGRO_KEY_ESCAPE:
				done = true;
				break;
			case ALLEGRO_KEY_LEFT:
				keys[LEFT] = true;
				break;
			case ALLEGRO_KEY_RIGHT:
				keys[RIGHT] = true;
				break;
			case ALLEGRO_KEY_UP:
				keys[UP] = true;
				break;
			case ALLEGRO_KEY_DOWN:
				keys[DOWN] = true;
				break;
			case ALLEGRO_KEY_SPACE:
				keys[SPACE] = true;
				if (state == TITLE)
					ChangeState(state, PLAYING);
				else if (state == LOST)
					ChangeState(state, PLAYING);
				else {
					if (state == PLAYING && prota->getGun()) {
						prota->shoot();
						al_play_sample(shot, 1, 0, 1, ALLEGRO_PLAYMODE_ONCE, 0);
					}
				}
				break;
			case ALLEGRO_KEY_C:
				keys[ACTION] = !keys[ACTION];
				prota->setInfo(keys[ACTION]);
				break;
			case ALLEGRO_KEY_TAB:
				keys[TAB] = true;
				break;
			}
		}
		else if (ev.type == ALLEGRO_EVENT_KEY_UP ) {
			switch (ev.keyboard.keycode) {
			case ALLEGRO_KEY_ESCAPE:
				done = true;
				break;
			case ALLEGRO_KEY_LEFT:
				keys[LEFT] = false;
				break;
			case ALLEGRO_KEY_RIGHT:
				keys[RIGHT] = false;
				break;
			case ALLEGRO_KEY_UP:
				keys[UP] = false;
				break;
			case ALLEGRO_KEY_DOWN:
				keys[DOWN] = false;
				break;
			case ALLEGRO_KEY_SPACE:
				keys[SPACE] = false;
				break;
			case ALLEGRO_KEY_TAB:
				keys[TAB] = false;
				break;
			}
		}

		if (state == PLAYING) {
			bool velY = false, velX = false;// Tiene velocidad en el eje x/y ?

			if (keys[UP]) {
				(*Rooms.begin())->boundary(UP);
				prota->MoveUp();
				keys[ACTION] = false;
			}

			else if (keys[DOWN]) {
				(*Rooms.begin())->boundary(DOWN);
				prota->MoveDown();
				keys[ACTION] = false;
			}
			else {
				prota->ResetAnimation(1);
			}
			
			if (keys[LEFT]) {
				(*Rooms.begin())->boundary(LEFT);
				prota->MoveLeft();
				keys[ACTION] = false;
			}

			else if (keys[RIGHT]) {
				(*Rooms.begin())->boundary(RIGHT);
				prota->MoveRight();
				keys[ACTION] = false;
			}
			else { 
				prota->ResetAnimation(0);
			}


			//update
			prota->Update();
			(*Rooms.begin())->Update();

			if (prota->GetLife() <= 0) {
				ChangeState(state, LOST);
				prota->add_Dead();
			}
		}
		//==============================================
		//GAME UPDATE
		//==============================================
		if (ev.type == ALLEGRO_EVENT_TIMER) {
			render = true;

			//UPDATE FPS===========
			frames++;
			if (al_current_time() - gameTime >= 1) {
				gameTime = al_current_time();
				gameFPS = frames;
				frames = 0;
			}
			//=====================
		}
		//cambio de sala
		if (prota->getChange()) {
			int room = prota->getRoom();
			int ID = prota->getType_Room();
			//Set 0:up 1:down 2:left 3:right 
			if (room == 0) {
				Room0 *bg = new Room0(bgImage, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 1) {
				if (ID == 0) {
					Room1 *bg = new Room1(bgImage1, prota, ID);
					Rooms.push_back(bg);
				}
				else if (ID == 1) {
					Room1 *bg = new Room1(bgImage11, prota, ID);
					Rooms.push_back(bg);
				}
			}
			else if (room == 2) {
				Room2 *bg = new Room2(bgImage2, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 3) {
				Room3 *bg = new Room3(bgImage3, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 4) {
				Room4 *bg = new Room4(bgImage4, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 5) {
				Room5 *bg = new Room5(bgImage5, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 6) {
				Room6 *bg = new Room6(bgImage6, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 7) {
				Room7 *bg = new Room7(bgImage7, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 8) {
				Room8 *bg = new Room8(bgImage8, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 9) {
				Room9 *bg = new Room9(bgImage9, prota, ID);
				Rooms.push_back(bg);
			}
			else if (room == 10) {
				Room10 *bg = new Room10(bgImage10, prota, ID);
				Rooms.push_back(bg);
			}
			//Aparece por -> 0:up 1:down 2:left 3:right 
			if (prota->getSet() == UP) {
				prota->SetX(310);
				prota->SetY(420);
			}
			else if (prota->getSet() == DOWN) {
				prota->SetX(310);
				prota->SetY(70);
			}
			else if (prota->getSet() == LEFT) {
				prota->SetX(570);
				prota->SetY(240);
			}
			else if (prota->getSet() == RIGHT) {
				prota->SetX(70);
				prota->SetY(240);
			}
			prota->destroy_ammo();
			(*Rooms.begin())->Destroy();
			delete(*Rooms.begin());
			Rooms.erase(Rooms.begin());
			prota->setChange(false);
		}

		//==============================================
		//RENDER
		//==============================================
		if (render && al_is_event_queue_empty(event_queue)) {
			render = false;

			//BEGIN PROJECT RENDER================
			if (state == TITLE) {
				titleScreen->Render();
				al_draw_textf(font, al_map_rgb(255, 255, 255), 320, 100, ALLEGRO_ALIGN_CENTRE, "Bad Trip");
				al_draw_textf(font, al_map_rgb(255, 255, 255), 320, 400, ALLEGRO_ALIGN_CENTRE, "Presione espacio para continuar");
			}
			else if (state == PLAYING) {
				Rooms.front()->Render();
				//al_draw_textf(font, al_map_rgb(255, 0, 255), 300, 5, 0, "FPS: %i", gameFPS);	//display FPS on screen
				life->Render();
				prota->Render();
				al_draw_textf(font1, al_map_rgb(62, 4, 61), 60, 5, ALLEGRO_ALIGN_CENTRE, "~%i~", prota->GetLife());
				if(keys[TAB])
					al_draw_bitmap(mapImage, 30, 50, 0);
			}
			else if (state == LOST) {
				lostScreen->Render();
				al_draw_textf(font, al_map_rgb(255, 255, 255), 320, 100, ALLEGRO_ALIGN_CENTRE, "Estas Muerto :D");
				al_draw_textf(font, al_map_rgb(255, 255, 255), 320, 400, ALLEGRO_ALIGN_CENTRE, "Presione espacio para continuar");
			}
			else if (state == WIN_DEMO) {
				al_draw_textf(font, al_map_rgb(255, 255, 255), 320, 100, ALLEGRO_ALIGN_CENTRE, "Gracias por jugar e.e");
				al_draw_textf(font, al_map_rgb(255, 255, 255), 320, 400, ALLEGRO_ALIGN_CENTRE, "Presione espacio para continuar");
			}
			//FLIP BUFFERS========================
			al_flip_display();
			al_clear_to_color(al_map_rgb(0, 0, 0));
		}
	}
	//==============================================
	//DESTROY PROJECT OBJECTS
	//==============================================
	prota->Destroy();
	delete(prota);
	titleScreen->Destroy();
	lostScreen->Destroy();
	delete titleScreen;
	delete lostScreen;

	al_destroy_bitmap(protaImage);
	al_destroy_bitmap(bgImage);
	al_destroy_bitmap(titleImage);
	al_destroy_bitmap(expImage);
	al_destroy_bitmap(lostImage);
	al_destroy_sample(shot);
	al_destroy_sample(boom);
	al_destroy_sample(song);
	al_destroy_sample_instance(songInstance);

	//SHELL OBJECTS=================================
	al_destroy_font(font);
	al_destroy_font(font1);
	al_destroy_timer(timer);
	al_destroy_event_queue(event_queue);
	al_destroy_display(display);

	return 0;
}
/*! @brief Metodo ChangeState.
*			Cambia el estado de juego.
*
* El juego tiene diferentes estados enumerados en un enum en Globals.h,
* nos permiten darnos cuenta en que fase se encuentra el juego y segn esto
* ejecutar diferentes funciones.
*/
void ChangeState(int &state, int newState){
	if(state ==TITLE){}
	else if(state == PLAYING){ 
		prota->Render();
		al_stop_sample_instance(songInstance);
	}
	else if(state == LOST){}

	state = newState;

	if(state ==TITLE){}
	else if(state == PLAYING){
		prota->new_Init();
		al_play_sample_instance(songInstance);
	}
	else if(state == LOST){}
}